#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include <randlib_c/randlib.h>

int
main(int argc, char *argv[])
{
  long seed1;
  long seed2;
  long block;
  size_t nran;
  size_t n;
  int idx = 1;
  char *endptr = NULL;

  if ( argc < 5 )
  {
    fprintf( stderr, "usage: genran seed1 seed2 block nran\n" );
    return EXIT_FAILURE;
  }
  
  seed1 = strtol( argv[idx++], &endptr, 10 );
  assert( *endptr == '\0' );

  seed2 = strtol( argv[idx++], &endptr, 10 );
  assert( *endptr == '\0' );

  block = strtol( argv[idx++], &endptr, 10 );
  assert( *endptr == '\0' );

  nran = strtol( argv[idx++], &endptr, 10 );
  assert( *endptr == '\0' );

  /* initialize random number generator and get to correct block */
  setall( seed1, seed2 );

  /* increment block to match what is used by test_scatter when
     invoking scatter.  increment this here to make it easier
     to use the same value of block everywhere */
     
  block++;
  for ( n = 0; n < block; n++ )
    initgn( 1 );


  for ( n = 0 ; n < nran ; n++ )
  {
    double rannum = 2.0 * ( ranf() - 0.5 );
    int is_neg = ( rannum < 0.0 );

    rannum = fabs(rannum);

    printf( "%.14g %d\n", rannum, is_neg ? -1 : 1 );
  }

  return EXIT_SUCCESS;

}
